> This page is for API Reference.

> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://docs.navipartner.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://docs.navipartner.com/_mcp/server.

# List Memberships

GET https://api.npretail.app/{tenant}/{environment}/{company}/membership/list

Retrieve a list of memberships. This endpoint supports pagination and filtering. Page size default is 100, maximum is 1000.

Reference: https://docs.navipartner.com/apis/api-reference/memberships/service-misc/list-memberships

## Authentication

- `x-np-api-key` header (required) — API Key authentication via header

## Request

### Path parameters

- `tenant` (string, required) — Your Entra Tenant ID. [More details.](/paths#1-tenant)
- `environment` (string, required) — Your Business Central Environment. [More details.](/paths#2-environment)
- `company` (string, required) — Your Business Central Company. [More details.](/paths#3-company)

### Query parameters

- `pageSize` (integer, optional)
- `pageKey` (string, optional)
- `communityCode` (string, optional)
- `membershipCode` (string, optional)
- `customerNumber` (string, optional)
- `blocked` (boolean, optional)
- `issueDate` (datetime, optional)
- `issuedFromDate` (datetime, optional)
- `issuedUntilDate` (datetime, optional)

## Response

### 200

- `morePages` (boolean, required)
- `data` (list of MembershipEntity, required)
- `nextPageKey` (string, optional)
- `nextPageURL` (string, optional)

## Types

### MembershipEntity

The MembershipEntity describes the basic attributes of a Membership.

- `membershipId` (UUID, required) — Unique identifier for a membership.
- `membershipNumber` (string, required) — Unique membership number.
- `communityCode` (string, required) — Code representing the community associated with the membership.
- `membershipCode` (string, required) — Code representing the type of membership.
- `membershipDescription` (string, required) — Description of the membership type.
- `issueDate` (date, required) — The date the membership was issued.
- `blocked` (boolean, required) — Indicates whether the entity is blocked.
- `autoRenewalActivated` (boolean, required) — Indicates if the membership is set to auto-renew.
- `validFromDate` (date, optional) — Start of the consecutive frame of the membership that is currently valid. `null` when the frame has no defined start — perpetual memberships, activate-on-first-use memberships that haven't been used yet, or memberships that aren't currently valid.
- `validUntilDate` (date, optional) — End of the consecutive frame of the membership that is currently valid. `9999-12-31` for perpetual memberships. `null` when the frame has no defined end — activate-on-first-use memberships that haven't been used yet, or memberships that aren't currently valid.
- `customerNumber` (string, optional) — Customer number associated with the membership.
- `documentId` (string, optional) — Unique identifier for the membership document.
- `blockedAt` (datetime, optional) — Date and time when the entity was blocked.
- `attributes` (list of AttributeValueListResponse, optional)

### AttributeValueListResponse

This response contains a list of attribute values associated with a specific membership entity.

- `id` (UUID, required)
- `code` (string, required) — The key code for the attribute. This is a unique identifier for the attribute.
- `type` (enum, required) — The datatype of the attribute.
  - Allowed values: `text`, `code`, `date`, `datetime`, `decimal`, `integer`, `boolean`, `unknown`
- `caption` (string, required) — The caption of the attribute.
- `value` (string, required) — The value of the attribute. This is the actual data associated with the attribute.

## Examples

**Response**

```json
{
  "morePages": true,
  "data": [
    {
      "membershipId": "cdef7890-abcd-0123-1234-567890abcdef",
      "membershipNumber": "MS-DEMO-00152",
      "communityCode": "RIVERLAND",
      "membershipCode": "GOLD",
      "membershipDescription": "Gold Membership with premium benefits",
      "issueDate": "2024-09-17",
      "blocked": false,
      "autoRenewalActivated": true,
      "validFromDate": "2024-09-17",
      "validUntilDate": "2025-09-16",
      "customerNumber": "D000188",
      "attributes": []
    }
  ],
  "nextPageKey": "c29tZSBiYXNlNjQgc3RyaW5n",
  "nextPageURL": "https://api.npretail.app/tenant/env/company/membership/list?pageKey=c29tZSBiYXNlNjQgc3RyaW5n"
}
```

**SDK Code**

```python
import requests

url = "https://api.npretail.app/01234567-89ab-cdef-0123-456789abcdef/production/CRONUS%2520International%2520Ltd./membership/list"

querystring = {"pageSize":"1","membershipCode":"GOLD"}

headers = {"x-np-api-key": "<NaviPartner API Key>"}

response = requests.get(url, headers=headers, params=querystring)

print(response.json())
```

```javascript
const url = 'https://api.npretail.app/01234567-89ab-cdef-0123-456789abcdef/production/CRONUS%2520International%2520Ltd./membership/list?pageSize=1&membershipCode=GOLD';
const options = {method: 'GET', headers: {'x-np-api-key': '<NaviPartner API Key>'}};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"net/http"
	"io"
)

func main() {

	url := "https://api.npretail.app/01234567-89ab-cdef-0123-456789abcdef/production/CRONUS%2520International%2520Ltd./membership/list?pageSize=1&membershipCode=GOLD"

	req, _ := http.NewRequest("GET", url, nil)

	req.Header.Add("x-np-api-key", "<NaviPartner API Key>")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://api.npretail.app/01234567-89ab-cdef-0123-456789abcdef/production/CRONUS%2520International%2520Ltd./membership/list?pageSize=1&membershipCode=GOLD")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Get.new(url)
request["x-np-api-key"] = '<NaviPartner API Key>'

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.get("https://api.npretail.app/01234567-89ab-cdef-0123-456789abcdef/production/CRONUS%2520International%2520Ltd./membership/list?pageSize=1&membershipCode=GOLD")
  .header("x-np-api-key", "<NaviPartner API Key>")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('GET', 'https://api.npretail.app/01234567-89ab-cdef-0123-456789abcdef/production/CRONUS%2520International%2520Ltd./membership/list?pageSize=1&membershipCode=GOLD', [
  'headers' => [
    'x-np-api-key' => '<NaviPartner API Key>',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://api.npretail.app/01234567-89ab-cdef-0123-456789abcdef/production/CRONUS%2520International%2520Ltd./membership/list?pageSize=1&membershipCode=GOLD");
var request = new RestRequest(Method.GET);
request.AddHeader("x-np-api-key", "<NaviPartner API Key>");
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = ["x-np-api-key": "<NaviPartner API Key>"]

let request = NSMutableURLRequest(url: NSURL(string: "https://api.npretail.app/01234567-89ab-cdef-0123-456789abcdef/production/CRONUS%2520International%2520Ltd./membership/list?pageSize=1&membershipCode=GOLD")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "GET"
request.allHTTPHeaderFields = headers

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```